Skip to main content
`Ctrl`+`K`

# VecMDot

Computes multiple vector dot products.

## Synopsis

    #include "petscvec.h"
    PetscErrorCode VecMDot(Vec x, PetscInt nv, const Vec y[], PetscScalar val[])

Collective

## Input Parameters

- x - one vector

- nv - number of vectors

- y - array of vectors.

## Output Parameter

- val - array of the dot products (does not allocate the array)

## Notes for Users of Complex Numbers

For complex vectors, `VecMDot()` computes

      val = (x,y) = y^H x,

where y^H denotes the conjugate transpose of y.

Use `VecMTDot()` for the indefinite form

      val = (x,y) = y^T x,

where y^T denotes the transpose of y.

## Note

The implementation may use BLAS 2 operations when the vectors `y` have been obtained with `VecDuplicateVecs()`

## See Also

Vectors and Parallel Data, `Vec`, `VecMTDot()`, `VecDot()`, `VecDuplicateVecs()`

## Level

intermediate

## Location

src/vec/vec/interface/rvector.c

## Examples

src/vec/vec/tutorials/ex20f90.F90
src/vec/vec/tutorials/ex1.c
src/vec/vec/tutorials/ex1f90.F90

## Implementations

VecMDot_MPIKokkos() in src/vec/vec/impls/mpi/kokkos/mpikok.kokkos.cxx
VecMDot_MPIViennaCL() in src/vec/vec/impls/mpi/mpiviennacl/mpiviennacl.cxx
VecMDot_MPI() in src/vec/vec/impls/mpi/pvec2.c
VecMDot_Nest() in src/vec/vec/impls/nest/vecnest.c
VecMDot_Seq() in src/vec/vec/impls/seq/dvec2.c
VecMDot_Seq() in src/vec/vec/impls/seq/dvec2.c
VecMDot_SeqKokkos() in src/vec/vec/impls/seq/kokkos/veckok.kokkos.cxx
VecMDot_SeqViennaCL() in src/vec/vec/impls/seq/seqviennacl/vecviennacl.cxx

Index of all Vec routines
Table of Contents for all manual pages
Index of all manual pages